#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: domain_menu.cgi,v 1.1.1.1 2005/05/25 16:47:05 ynakam Exp $

# Displays domain/role ACL configuration menu
use CGI qw(:standard);
do "./common.pl";

$Jscript =<<"EOL";
function change() {
    index = document.form.elements["domain_select"].selectedIndex;
    value = document.form.elements["domain_select"].options[index].text;
    parent.domain_menu.location.href="domain_menu.cgi?domain="+value;
    parent.config.location.href="blank.cgi?domain="+value;
    //alert(value);
}

EOL

local $Policy_root = set_policy_root();

local %Domain_list;
&read_domain_list(\%Domain_list,$Policy_root);
delete($Domain_list{"global"});

my $selected = "init_t";	#the name of domain selected by list box

$selected = param("domain");

&print_menu($selected);

sub print_menu($) {
    my $selected;
    $selected = $_[0];

    &print_header();
    print start_html(-lang=>'japanese',-title=>$text{"acl_conf"},-script=>{-code=>$Jscript,-language=>'JavaScript'});

    print "<LINK REL = STYLESHEET TYPE=\"text/css\" HREF=\"selinux.css\" TITLE=\"selinux\">";
    print h2($text{"acl_conf"});
    print a({-href=>"index.cgi",-target=>"_top"},$text{"back_to_menu"}),p;
    print $text{"target_domain"},br;

    my @domain_array = keys(%Domain_list);
    @domain_array = sort(@domain_array);
    unshift @domain_array,"global";
    unshift @domain_array,"";
    print start_form(-method=>"post",-acion=>"domain_menu.cgi",-name=>"form");#dummy
	print scrolling_list(-name=>"domain_select",-values=>\@domain_array,-onchange=>"change()",-size=>"1",-default=>"$selected");

    if ($selected eq "")
    {
	;
    }
    else
    {
	print p,a({-href=>"file_acl_edit.cgi?domain=$selected",-target=>"config"},$text{"file_acl"}),p;
	print p,a({-href=>"netacl_edit.cgi?domain=$selected",-target=>"config"},$text{"net_acl"}),p;
	print p,a({-href=>"ipcacl_edit.cgi?domain=$selected",-target=>"config"},$text{"ipc_acl"}),p;
	print p,a({-href=>"ttyacl_edit.cgi?domain=$selected",-target=>"config"},$text{"tty_acl"}),p;
	print p,a({-href=>"admacl_edit.cgi?domain=$selected",-target=>"config"},$text{"admin_acl"}),p;
	print p,a({-href=>"procacl_edit.cgi?domain=$selected",-target=>"config"},$text{"proc_acl"}),p;
	print p,a({-href=>"tmpfsacl_edit.cgi?domain=$selected",-target=>"config"},$text{"tmpfs_acl"}),p;
	print p,a({-href=>"template.cgi?domain=$selected",-target=>"config"},$text{"apply_template"}),p;

    }

    print end_html();
}
