#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: domain_trans_edit.cgi,v 1.1.1.1 2005/05/25 16:47:05 ynakam Exp $

use CGI qw(:standard);
require './domain_trans_lib.pl';

local $Policy_root=set_policy_root();

@tmp=split(/&/,$ENV{'QUERY_STRING'});
foreach (@tmp)
{
    my @tmp2;
    @tmp2=split(/=/,$_);
    $query{$tmp2[0]}=$tmp2[1];
}

if (!exists $query{"domain"} && !exists $query{"parentdomain"})
{
    print_instruction();

    return;
}

$current_domain=$query{"domain"};
$parant_domain=$query{"parentdomain"};
$option=$query{"option"};

if ($option eq "add")
{
    $parant_domain=$current_domain;
    $current_domain="";
}

#list of domain names
local %Domain_list;
&read_domain_list(\%Domain_list,$Policy_root);

&print_form($option);

sub print_instruction()
{
    &print_header();
    print "<SCRIPT language=\"JavaScript\" src=\"domain_trans.js\"></SCRIPT>\n";
    print start_html(-title=>$text{"domain_trans"}),
    h2($text{"select_msg"});
    end_html();
}

sub print_form($) {
    &print_header();
    print "<SCRIPT language=\"JavaScript\" src=\"domain_trans.js\"></SCRIPT>\n";
    print "<LINK REL = STYLESHEET TYPE=\"text/css\" HREF=\"selinux.css\" TITLE=\"selinux\">";

    my $notchange=$text{"notchanged"};
    print start_html(-title=>$text{"domain_trans"},-onUnload=>"check_changed(\'$notchange\')");

    if ($option eq "add")
    {
	print h2($text{"add_new_trans"});
    }
    else
    {
	print h2($text{"edit_trans"});
    }

    print start_form(-method=>"post",-action=>"setdomain.cgi",-name=>"edit_form"),hidden(-name=>"changed",-value=>"0"),
    $text{"domain_name"},p;

    if ($option eq "add")
    {
	delete $Domain_list{"global"};

	my  @domain_array=keys %Domain_list;
	@domain_array=sort @domain_array;
	unshift @domain_array,"";
	my %labelhash;

	foreach (@domain_array)
	{
	    $labelhash{$_}=$_;
	}

	print textfield(-name=>'domain_name',-size=>'20',-value=>"$current_domain",-readonly=>"",-onChange=>"set_change()");
	print " ".scrolling_list(-name=>"select",-values=>\@domain_array,-size=>1,-labels=>\%labelhash,-onChange=>"select_domain()");

    }
    else
    {
	print hidden(-name=>'domain_name',value=>"$current_domain");
	print $current_domain;
    }
    print p;

    if ($current_domain ne "")
    {
	my $comment;
	$comment=&read_comment($current_domain,$Policy_root);
	print $text{"comment"},p,
	textfield(-name=>'comment',-size=>'60',-value=>$comment,-onChange=>"set_change()"),
	p;
    }

    if ($parant_domain ne "")
    {
	print $text{"parent_domain"},p,$parant_domain,
	hidden(-name=>"parent_domain",-value=>"$parant_domain"),
	p;
	print  $text{"entry_point"},p;
	#calculate entry point
	$ref=$Domain_trans_rule{$current_domain};

	foreach (@$ref)
	{
	    @tmp=split(/,/,$_);
	    if ($tmp[0] eq $parant_domain)
	    {
		push @entry,$tmp[1];
	    }
	}
	print textfield(-name=>'entry_text',-size=>'50',-value=>"@entry",-onChange=>"set_change");

	if ($option ne "add")
	{
	    print p,checkbox(-name=>'delete',-label=>$text{"del_trans"},-checked=>0,-onChange=>"set_change()"),p;
	}
    }

    print p,submit(-value=>$text{"apply"},-onClick=>"unset_change()"),end_form;

    print end_html(); 
}
