#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: domain_trans_popup.cgi,v 1.1.1.1 2005/05/25 16:47:06 ynakam Exp $

use CGI qw(:standard);
require './domain_trans_lib.pl';

$JScript=<<"EOL";
function change(domain,parentdomain) {
    for (i=0;i<document.select_form2.option.length;i++)
    {
	if (document.select_form2.option[i].checked)
	{
	    break;
	}
    }

    value=document.select_form2.option[i].value;
    window.parent.opener.parent.frame2.location.href="domain_trans_edit.cgi?domain="+domain+"&parentdomain="+parentdomain+"&option="+value;
}


EOL


&print_header();

$parent=param("parent");
$domain=param("domain");
$flag=param("flag");

local @coordinate;
print "<HTML> <HEAD> <TITLE>popup</TITLE>";
print "<SCRIPT language=\"JavaScript\" src=\"domain_trans.js\">";
#print "<!--\n";
#print $JScript;
#print "// -->\n";
print "</SCRIPT>\n";
print "<LINK REL = STYLESHEET TYPE=\"text/css\" HREF=\"selinux.css\" TITLE=\"selinux\">";

print $text{"domain_trans"},p;
print start_form(-method=>"post",-action=>"domainedit.cgi",-name=>"select_form");
print radio_group(-name=>"option",-values=>["add","change"],-default=>$flag,-labels=>{"add"=>$text{"add_new_trans"},"change"=>$text{"edit_trans"} });
print end_form;"\n";

my $last_y;

#print $flag,p;
local %buf;
$last_y=print_popup_tree("$domain",0,0,-1,-1,\@coordinate,\%buf);
&print_line(0,-50,\@coordinate);
undef @coordinate;
undef %buf;

print end_html();


#Draw tree recursively based on %Domain_trans_tree
#$domain_name
sub print_popup_tree($$$$$$$$) {
    my $domain_name;
    my $x;
    my $y;
    my $parent_x;
    my $parent_y;
    my $coord_ref;		#buffer for tree coordinate
    my $printed_node;		#referrence to hash,register printed nodes.
    my $ref;
    my $opt;
    my $init_x=10;
    my $init_y=70;

    ($domain_name,$x,$y,$parent_x,$parent_y,$coord_ref,$printed_node,$opt)=@_;

    my $left_space=$x*24+$init_x;
    my $top_space=$y*25+$init_y;

    push @$coord_ref,"$x,$y";

    my $parent_domain_name;
    my @tmp;
    @tmp=split(/,/,$tree_node{"$parent_x,$parent_y"});
    $parent_domain_name=$tmp[0];

    print "<DIV STYLE=\"position:absolute;visibility:visible;left:$left_space;top:$top_space;font-size:12pt\" ID=\"t$y\">";
    print "<NOBR>";

    print a({-href=>"Javascript:onClick=change_popup(\'$domain_name\',\'$parent_domain_name\')"},"$domain_name");

    if (exists($$printed_node{$domain_name})&&(exists $Domain_trans_tree{$domain_name}))
    {
	print " ";
	print a({-href=>"Javascript:onClick=update_domain_tree(\'$parent_domain_name\',\'$domain_name\')"},"---->");
#    print "---->";
    }
    print "</NOBR>";
    print "</DIV>\n";


    #if $domain_name is printed before print only node.
    if (exists($$printed_node{$domain_name}))
    {
	$y--;
	return $y;
    }

    $$printed_node{$domain_name}=1;

    $tree_node{"$x,$y"}="$domain_name,$parent_x,$parent_y";


    if (!exists($Domain_trans_tree{$domain_name}))
    {
	return $y-1;
    }

    $ref=$Domain_trans_tree{$domain_name};

    my %called_domain;
    my $current_x=$x;
    my $current_y=$y;
    my $flag=0;

    foreach (@$ref)
    {
	my @tmp;
	my $d;
	@tmp=split(/,/);
	$d=$tmp[0];

	if (exists($called_domain{$d}))
	{				#This is not to display domains whose (from,to) is the same but prog is different.
	    next;
	}
	else
	{
	    $called_domain{$d}=1;
	}

	if (&check_loop($d,$current_x,$current_y)==0 )
	{						#detect loop
	    $y=&print_popup_tree($d,$x+1,$y+1,$current_x,$current_y,$coord_ref,$printed_node,$opt);
	    $y++;
	}
	else
	{
	    $y++;
	    $x++;
	    my $left_space=$x*24+$init_x;
	    my $top_space=$y*25+$init_y;
	    push @$coord_ref,"$x,$y";
	    $x--;

	    print "<DIV STYLE=\"position:absolute;visibility:visible;left:$left_space;top:$top_space;font-size:12pt\" ID=\"t$y\">";
	    print "<NOBR>";

	    if ($flag == 0)
	    {
		print a({-href=>"Javascript:onClick=change_popup(\'$d\',\'$domain_name\')"},"$d");
		print " ";
#	print a({-href=>"Javascript:onClick=update_domain_tree(\'$domain_name\',\'$d\')"},"---->");
		#print "---->";
		$flag=1;
	    }
	    else
	    {
		print ",$d";
	    }
	    print "</NOBR>";
	    print "</DIV>\n";
	}
    }
    $y--;

    return $y;
}
