#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: postinstall.cgi,v 1.2 2005/06/24 18:59:40 ynakam Exp $

use Fcntl;
do 'common.pl';
use CGI qw(:standard);

&print_header();
print start_html(-lang=>'japanese',-title=>"postinstall");
&module_install();
print end_html();


#When module is installed,this script runs first.
#copy config to /etc/webmin
sub module_install() {
    #copy "config"
    system("cp $module_root_directory/config $config_directory/selinux/config")
	if (!-r "$config_directory/selinux/config");

    #reset path to webmin.
    my $root=set_policy_root();
    my %Domain_list;
    &read_domain_list(\%Domain_list,$root);
    foreach $domain(keys(%Domain_list))
    {
	&correct_webmin_path($domain,$root);
    }

   
}

sub correct_webmin_path($$) {
    my $domain;
    my $root;
    ($domain,$root)=@_;

    my @buf;
    my @dummy;
    &read_conf_file_skip($domain,$root,\@buf,\@dummy);

    my @outbuf;
    foreach (@buf)
    {
	my $line=$_;
	$line=~s/\/usr\/local\/webmin-[^\/;]*\//$root_directory\//;
	$line=~s/\/usr\/local\/webmin-[^\/\s\t;]*/$root_directory/;
	push @outbuf,$line;
    }

    &write_buf($domain,$root,\@outbuf);
}

