#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: rm.cgi,v 1.1.1.1 2005/05/25 16:47:06 ynakam Exp $

# remove file associated with domain/role
#
use Fcntl;
use CGI qw(:standard);
require "common.pl";

local $Policy_root=set_policy_root();

my $domain=param("domain");

my $filename=$Policy_root."/".$domain.".a";

if (!(-e $filename))
{
    &print_header();
    print "ERROR:".&text("not_exist",$filename);
    exit;
}

unlink($filename);

#&print_header();

#delete the line related to deleted domain.
my %domain_list;

&read_domain_list(\%domain_list,$Policy_root);

my $key;

foreach $key (keys(%domain_list)) {
    my @buf;
    my @skip;
    push @skip,"[\\s\\t]*[^#]$domain";

    &read_conf_file_skip($key,$Policy_root,\@buf,\@skip);
    &write_conf_file($key,$Policy_root,\@buf);

    undef @buf;
    undef @skip;
}

redirect("del_domain.cgi?del=$domain");

sub write_conf_file($$$) {
    my $domain;
    my $path;
    my $buf_ref;
    my $filename;

    ($domain,$path,$buf_ref)=@_;

    if ($domain eq "global")
    {
	$filename=$path."/global";
    }
    else
    {
	$filename=$path."/$domain".".a";
    }

    sysopen(FILE,"$filename",O_WRONLY|O_TRUNC| O_CREAT) or die "File open error:$filename\n";
#  open(FILE,">$filename") or die "File open error:$filename\n";


    print FILE "{\n";
    foreach (@$buf_ref)
    {
	print FILE "$_\n";
    }

    print FILE "}\n";
    close(FILE);
}
