#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: exc2_perm.cgi,v 1.1.1.1 2005/05/25 16:47:05 ynakam Exp $

#Show domain name lists which can access a "allow exclusive" label .

use CGI qw(:standard);
require './selinux-lib.pl';


#directory where the label belong.
local $current_dir;
#permission of $current_dir
local $default_perm;

local $relabel_flag;

local %Domainlist;
&read_domain_list(\%Domainlist,$Policy_root);

local $excname=param("excname");
local $current_dir=param("current_dir");
my $action_flag=param("switch");


&print_header();
print start_html();
print &text("exc_perm_title",$excname);
print p;

if($action_flag ne "all"){
  print start_form(-method=>"post",-action=>"exc2_perm.cgi",-name=>"select_form");
  print hidden(-name=>"excname",-value=>$excname);
  print hidden(-name=>"current_dir",-value=>$current_dir);
  print hidden(-name=>"switch",-value=>"all");
  print submit(-value=>$text{"show_all_domain"});
  print end_form();
}

#print $current_dir;
print start_form(-method=>"post",-action=>"set_exc2_perm.cgi",-name=>"edit_form");
print hidden(-name=>"excname",-value=>$excname);
print hidden(-name=>"current_dir",-value=>$current_dir);

local @table;
my $first_row_ref=["domain","r","w","x","s","c"];
push @table,th({-bgcolor=>"yellow"},$first_row_ref);

my $current_domain;
delete $Domainlist{"global"};#there is no allow exclusive in global domain
my @list=keys( %Domainlist);
@list=sort(@list);

foreach $current_domain (@list)
{
    my @row;

    my $search_flag;
    my $read_all_flag;
    my $write_all_flag;
    #  $relabel_flag=&check_relabel($current_domain,$Policy_root);
    $search_flag=&check_search_all($current_domain,$Policy_root);
    $read_all_flag=&check_adm($current_domain,$Policy_root,"read");
    $write_all_flag=&check_adm($current_domain,$Policy_root,"write");


    undef(%Exc_allow);
    if ($current_domain eq "global")
    {
	next;
    }
    &read_exc_file_acl($current_domain);

    my $perm;
    my $permstr;

    if (exists($Exc_allow{$excname}))
    {
	$perm=$Exc_allow{$excname};
    }
    else
    {
	$perm=$DENY;
    }

    $permstr=&perm_to_str($perm);

    if ($action_flag eq "all"||$permstr ne "DENY" || $search_flag == 1 || $read_all_flag == 1 || $write_all_flag == 1)
      {
	push @row,"$current_domain";

	print hidden(-name=>"name_$current_domain",-value=>1);
	&push_cell(\@row,$current_domain,$permstr,$read_all_flag,"r");
	&push_cell(\@row,$current_domain,$permstr,$write_all_flag,"w");
	my $dummy_flag=0;
	&push_cell(\@row,$current_domain,$permstr,$dummy_flag,"x");
	&push_cell(\@row,$current_domain,$permstr,$search_flag,"s");
	&push_cell(\@row,$current_domain,$permstr,$dummy_flag,"c");

	# if ($permstr =~ /r/ || $read_all_flag == 1)
# 	{
# 	    push @row ,$text{"ok"};
# 	}
# 	else
# 	{
# 	    push @row ,"-";
# 	}

# 	if ($permstr =~ /w/ || $write_all_flag == 1)
# 	{
# 	    push @row ,$text{"ok"};
# 	}
# 	else
# 	{
# 	    push @row ,"-";
# 	}

# 	if ($permstr =~ /x/)
# 	{
# 	    push @row ,$text{"ok"};
# 	}
# 	else
# 	{
# 	    push @row ,"-";
# 	}

# 	if ($permstr =~ /s/ || $search_flag == 1)
# 	{
# 	    push @row ,$text{"ok"};
# 	}
# 	else
# 	{
# 	    push @row ,"-";
# 	}

# 	if ($permstr =~ /c/)
# 	{
# 	    push @row ,$text{"ok"};
# 	}
# 	else
# 	{
# 	    push @row ,"-";
# 	}

	push @table,td(\@row);
    }
}

print table(Tr(\@table));
print hr;
print submit(-value=>$text{"apply"});
print end_form();
print end_html();


sub push_cell($$$){
  my $row_ref;
  my $domain;
  my $permstr;
  my $all_flag;
  my $pattern;
  ($row_ref,$domain,$permstr,$all_flag,$pattern)=@_;
  my $flag;

  if ($permstr=~/$pattern/){
    $flag=1;
  }else{
    $flag=0;
  }

  my $name;
  $name="$pattern"."_"."$domain";

  if($all_flag==1){

    if($flag==1){

      push @$row_ref,$text{"ok"}.hidden(-name=>"$name",-value=>"on");
    }else{
      push @$row_ref,$text{"ok"};
    }

  }else{
    push @$row_ref,checkbox(-name=>"$name",-value=>"on",-label=>"",-checked=>$flag);
  }

}

