#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: explore.cgi,v 1.1.1.1 2005/05/25 16:47:05 ynakam Exp $

#Show file-tree in File ACL Configuration.
use CGI qw(:standard);

print "Content-type: text/html\n\n";
print "<HTML> <HEAD> <TITLE>Kengen Explore</TITLE>";
print "<LINK REL = STYLESHEET TYPE=\"text/css\" HREF=\"selinux.css\" TITLE=\"selinux\">";

print "</HEAD>";
local %query;
local $current_dir;
local $current_domain;

$current_dir=param("filepath");

if ($current_dir eq ""||$current_dir eq "Root")
{
    $current_dir="/";
}
$current_domain=param("domain");

if ($current_domain eq "")
{
    $current_domain="global";
}

print_tree();

print "</HTML>";

sub print_tree() {
    my $i;
    my $j;
    my $fullpath;
    my $name;
    my $child_x;
    my $child_y;
    my $offset=2;

    &print_folder("Root","Root",1,1,"images/linkto_c.gif");

    @tokens=split(/\//,$current_dir);
    $len=@tokens;
    if ($len==0)
    {
	print_folder("/","/",$offset,$offset,"images/minus.gif");
    }
    else
    {
	print_folder("/","/",$offset,$offset,"images/linkto_c.gif");
    }

    #Show parent directory
    for ($i=1;$i<$len;$i++)
    {
	$name=$tokens[$i];

	$fullpath="/";
	for ($j=1;$j<$i+1;$j++)
	{
	    $fullpath=$fullpath.$tokens[$j]."/";
	}
	if ($fullpath ne "/")
	{
	    chop($fullpath);
	}

	print "<br>";

	if ($i==$len-1)
	{
	    print_folder($fullpath,$name,$offset+$i,$offset+$i,"images/minus.gif");
	}
	else
	{
	    print_folder($fullpath,$name,$offset+$i,$offset+$i,"images/linkto_c.gif");
	}
    }

    #Show child directory
    $child_x=$i+1;
    $child_y=$i+1;

    opendir(DIR,$current_dir) or die "could not open $current_dir:\n";

    #Information about directory to show
    #key:fullpath ,value:(name of directory,x coordinate,imagefile);
    my %folder_info;

    while ($_=readdir(DIR))
    {
	if ($_ eq "."||$_ eq "..")
	{
	    next;
	}

	if ($current_dir eq "/")
	{
	    $fullpath=$current_dir.$_;
	}
	else
	{
	    $fullpath=$current_dir."/".$_;
	}

	#don't follow symbolic links
	if ( -l $fullpath)
	{
	    next;
	}

	if ( -d $fullpath)
	{
	    $folder_info{$fullpath}="$_,$child_x,images/plus_c.gif";
	}
    }

    #show sorted directory list
    my @key;
    @key=keys %folder_info;
    @key=sort @key;

    my $k=0;
    foreach  (@key)
    {
	my @args;
	@args=split(/,/, $folder_info{$_});
	print_folder($_,$args[0],$args[1]+1,$child_y+$k+1,$args[2]);
	$k++;
    }

    closedir(DIR);
}



#print_folder(path,left,top,image)
#path:path to directory
#dname :name of directory
#left:the position from left 
#top:the position from top 
#image:path to icon file
sub print_folder() {
    my $left;
    my $top;
    my $path;
    my $dname;
    my $image;
    my $top_space;
    my $left_space;
    my $query_string;
    ($path,$dname,$left,$top,$image)=@_;

    $top_space=($top-1)*20+10;
    $left_space=($left-1)*23+10;

    print "<DIV STYLE=\"position:absolute;visibility:visible;left:$left_space;top:$top_space;font-size:12pt\" ID=\"t$top\">";
    print "<NOBR>";
    my $encpath;

#encode URL
    $encpath=$path;
    $encpath =~ s/([^\.\*\-_a-zA-Z0-9 ])/sprintf("%%%02lX",unpack("C",$1))/eg;
    $encpath =~ s/ /+/g;

    if ($path eq "Root")
    {
	;
    }
    else
    {
	print "<A HREF=\"explore.cgi?filepath=$encpath&domain=$current_domain\"><IMG SRC=\"$image\" NAME=\"i$top\" BORDER=\"0\" ALIGN=\"top\"></A>";
    }

    print "<A HREF=\"view.cgi?filepath=$encpath&domain=$current_domain\" target=\"frame2\" >$dname</A>";
    print "</NOBR>";
    print "</DIV>";
}
