#!/usr/bin/perl
# All Rights Reserved, Copyright (C) 2003, Hitachi Software Engineering Co., Ltd.
# $Id: show_fileacl_conf.cgi,v 1.1.1.1 2005/05/25 16:47:06 ynakam Exp $

#show all File ACLs of the domain

$JScript=<<"EOL";
function change(domain,dir) {
    window.parent.opener.parent.frame2.location.href="view.cgi?filepath="+dir+"&domain="+domain;
}
EOL


use CGI qw(:standard);
require './selinux-lib.pl';

$current_domain=param("domain");
if ($current_domain eq "")
{
    $current_domain="global";
}

if ($current_domain ne "global")
{
    &read_domain_file_acl($current_domain);
    &read_exc_file_acl($current_domain);
}

local %Dir_exc_hash;
get_dir_exc(\%Exc_dir,\%Dir_exc_hash);


&print_header();
print start_html(-lang=>'japanese',-title=>$text{"file_acl_all"},-script=>{-code=>$JScript,-language=>'JavaScript'});
print "<LINK REL = STYLESHEET TYPE=\"text/css\" HREF=\"selinux.css\" TITLE=\"selinux\">";


print h2(&text("file_acl_all_title",$current_domain));

my %key;
my @key;
my @tmp=keys(%Global_allow);
foreach (@tmp)
{
    $key{$_}=1;
}
my @tmp=keys(%Global_allowonly);
foreach (@tmp)
{
    $key{$_}=1;
}
my @tmp=keys(%Domain_allow);
foreach (@tmp)
{
    $key{$_}=1;
}
my @tmp=keys(%Domain_allowonly);
foreach (@tmp)
{
    $key{$_}=1;
}


@key=sort(keys %key);
foreach (keys(%Exc_allow))
{
    push @key,$_;
}

foreach (@key) {
    my $permstr;
    my $perm;
    my $dir;
    $dir=&get_dir($_);
    print a({-href=>"Javascript:onclick=change(\'$current_domain\',\'$dir\');"},"$_:");

    if (exists($Global_allow{$_}))
    {
	$perm=$Global_allow{$_};
	$permstr=&perm_to_str($perm);
	print span({style=>"color:red"},"$permstr ");
    }

    if (exists($Global_allowonly{$_}))
    {
	$perm=$Global_allowonly{$_};
	$permstr=&perm_to_str($perm);
	print span({style=>"color:red"},"only,$permstr ");
    }

    if (exists($Domain_allow{$_}))
    {
	$perm=$Domain_allow{$_};
	$permstr=&perm_to_str($perm);
	print "$permstr";
    }

    if (exists($Domain_allowonly{$_}))
    {
	$perm=$Domain_allowonly{$_};
	$permstr=&perm_to_str($perm);
	print "only,$permstr";
    }

    if (exists($Exc_allow{$_}))
    {
	$perm=$Exc_allow{$_};
	$permstr=&perm_to_str($perm);
	print "$permstr";
    }

    print br;
}



print end_html();

sub get_dir() {
    my $dir=$_[0];

    if (-d $dir)
    {
    }
    elsif (exists($Dir_exc_hash{$dir}))
    {
	$dir=$Dir_exc_hash{$dir};
    }
    else
    {
	if ($dir=~/\/.*\//)
	{
	    $dir=$&;
	}
	else
	{
	    $dir="/";
	}
    }

    return $dir;
}
