#!/usr/bin/perl
#compile configuration and reload configuration
use Fcntl;
use CGI qw(:standard);
require "common.pl";

$Jscript =<<"EOL";
function update_action(flag){
location.href="update.cgi?flag="+flag;
}
EOL

local $make_root =$config{"make_root"};
local $context_root =$config{"context_root"};
local $policy_root =$config{"policy_root"};

#flag used to decide the kind operation
$flag=param("flag");
if($flag eq ""){
$flag=0;
}

if($flag==0){
    &print_menu();
    return;
}

#construct command string
local $command;
local $msg;
if($flag==1){
    &part_relabel();
}elsif($flag==2){
    &compile_config();
}elsif($flag==3){
    &reload_config();
}elsif($flag==4){
    &relabelfile();
}
$command.=";";
$command.=&copy_default_context();

#execute command 
&print_header();
print start_html(-lang=>'japanese',-title=>$text{"update_conf"});
print $msg,br;
print $command,br;
$out=`($command) 2>&1`;
print $out,hr;
print p,a({-href=>"index.cgi"},$text{"back_to_menu"});
end_html();


sub part_relabel(){
  $command = "cd $make_root;"
      ."make diffrelabel";
  
}

sub compile_config(){
  $command = "cd $make_root;"
      ."make policy";
  
}

sub reload_config(){
  $command = "cd $make_root;"
      ."make reload";
  
}

sub relabelfile(){
    $msg = h2($text{"relabeling"});
    $msg.="##";
    $command = "cd $make_root;"
	."make relabel";
}

sub copy_default_context(){
    my $default_context_dir=$context_root."user";
    my $copy_command;
#construct command
    opendir(DIR,$policy_root) or die  "could not open $policy_root";
    while($_=readdir(DIR)){
	if($_=~/_default_contexts/){
	    my $src;
	    my $dest;
	    my $user;
	    $src = $policy_root."/".$_;
	    my $user=$_;
	    $user=~s/_default_contexts//;
	    $dest = $context_root."/users/".$user;
	    $copy_command.="cp $src $dest;";
	}
    }
    closedir(DIR);
    
    #print $copy_command,p;
    #my $out=`($copy_command) 2>&1`;
    #print $out,hr;
    return $copy_command;    
}

sub print_menu(){
  &print_header();
  print start_html(-lang=>'japanese',-title=>$text{"update_conf"},-script=>{-code=>$Jscript,language=>'JavaScript'});
  print "<LINK REL = STYLESHEET TYPE=\"text/css\" HREF=\"selinux.css\" TITLE=\"selinux\">";

  print start_form(-method=>"post",-action=>"update.cgi",-name=>"update");
  print h2($text{"update_conf"});
  print button(-label=>$text{"part_relabel"},-onclick=>"update_action(1)"),p;
  print button(-label=>$text{"reload"},-onclick=>"update_action(3)"),p;
  print button(-label=>$text{"relabel"},-onclick=>"update_action(4)"),p;
  print button(-label=>$text{"compile"},-onclick=>"update_action(2)"),p;


  print p,a({-href=>"index.cgi"},$text{"back_to_menu"});
  print end_form();
  print end_html();
}

